////////////////////////////////////////////////////////////////////////////////
// File         : ObjPrint.h
// Subsystem    : Graph
// Component    : trace objects
// Author       : Josef Huebl, (Josef.Huebl@sss.de)
// Description  : definition of the class ObjPrint
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) Triple-S GmbH (www.sss.de) 2003
// Alle Rechte vorbehalten. All Rights Reserved.
//
// The reproduction, transmission or use of this document or its contents is
// not permitted without express written authority.
// Offenders will be liable for damages. All rights, including rights created
// by patent grant or registration of a utility model or design, are reserved.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// History:
// 30.09.03    Josef Huebl       created
// 17.12.03    Josef Huebl       1. released version.
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Hints:      
// 
// This Object can be used to trace a derived object. 
// It stores a name and creates a new name, when the object is copied.  
//     
////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_OBJPRINT_H__9715BC97_10D3_4B87_BFE0_F274D70F907F__INCLUDED_)
#define AFX_OBJPRINT_H__9715BC97_10D3_4B87_BFE0_F274D70F907F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string.h>
#include <stdio.h>
#include <stdarg.h>

static const int ObjPrintNameSize = 256;
static const char *ObjPrintNoname = "Noname";

class ObjPrint  
{
public:
	ObjPrint( const char *type, const char *name = ObjPrintNoname );
	ObjPrint( const ObjPrint &obj, const char *name = ObjPrintNoname );
	virtual ~ObjPrint();
	const char *GetFullName( void ) const { return m_fullName; };
	void Print( char * comment = "" ... ) const;

private:
	char m_name[ ObjPrintNameSize ];
	char m_type[ ObjPrintNameSize ];
	unsigned int m_copy;
	char m_fullName[ 2*ObjPrintNameSize ];

protected:
	void Copy( const ObjPrint &obj, const char *name = ObjPrintNoname );
	virtual void PrintBody( void ) const {};

};

#endif // !defined(AFX_OBJPRINT_H__9715BC97_10D3_4B87_BFE0_F274D70F907F__INCLUDED_)
